/*
 * Copyright (c) 2003 VLSI Solution Oy
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' WITHOUT ANY WARRANTIES
 *
 * $Id: AT89C51ED2-SFR.h,v 1.1 2003-12-12 14:30:14+02 erkki Exp erkki $
 */

//Core SFRs
sfr at 0xE0 ACC;
sfr at 0xF0 B;
sfr at 0xD0 PSW;
sfr at 0x81 SP;
sfr at 0x82 DPL;
sfr at 0x83 DPH;

//System Management SFRs
sfr at 0x87 PCON;
sfr at 0x8E AUXR;
sfr at 0xA2 AUXR1;
sfr at 0x97 CKRL;

//Interrupt SFRs
sfr at 0xA8 IEN0;
sfr at 0xB1 IEN1;
sfr at 0xB7 IPH0;
sfr at 0xB8 IPL0;
sfr at 0xB3 IPH1;
sfr at 0xB2 IPL1;

sbit at 0xA8 EX0  ;
sbit at 0xA9 ET0  ;
sbit at 0xAA EX1  ;
sbit at 0xAB ET1  ;
sbit at 0xAC ES   ;
sbit at 0xAF EA   ;


//Serial port
sbit at 0x98 RI   ;
sbit at 0x99 TI   ;
sbit at 0x9A RB8  ;
sbit at 0x9B TB8  ;
sbit at 0x9C REN  ;
sbit at 0x9D SM2  ;
sbit at 0x9E SM1  ;
sbit at 0x9F SM0  ;

sbit at 0xD1 UDF  ;

/*  TCON  */
sbit at 0x8F TF1  ;
sbit at 0x8E TR1  ;
sbit at 0x8D TF0  ;
sbit at 0x8C TR0  ;
sbit at 0x8B IE1  ;
sbit at 0x8A IT1  ;
sbit at 0x89 IE0  ;
sbit at 0x88 IT0  ;




//Port SFRs
sfr at 0x80 P0;
sfr at 0x90 P1;
sfr at 0xA0 P2;
sfr at 0xB0 P3;
sfr at 0xC0 P4;
sfr at 0xD8 P5;

//Timer SFRs
sfr at 0x88 TCON;
sfr at 0x89 TMOD;
sfr at 0x8A TL0;
sfr at 0x8C TH0;
sfr at 0x8B TL1;
sfr at 0x8D TH1;
sfr at 0xA6 WDTRST;
sfr at 0xA7 WDTPRG;
sfr at 0xC8 T2CON;
sfr at 0xC9 T2MOD;
sfr at 0xCB RCAP2H;
sfr at 0xCA RCAP2L;
sfr at 0xCD TH2;
sfr at 0xCC TL2;

//PCA SFRs
sfr at 0xD8 CCON;
sfr at 0xD9 CMOD;
sfr at 0xE9 CL;
sfr at 0xF9 CH;
sfr at 0xDA CCAPM0;
sfr at 0xDB CCAPM1;
sfr at 0xDC CCAPM2;
sfr at 0xDD CCAPM3;
sfr at 0xDE CCAPM4;
sfr at 0xFA CCAP0H;
sfr at 0xFB CCAP1H;
sfr at 0xFC CCAP2H;
sfr at 0xFD CCAP3H;
sfr at 0xFE CCAP4H;
sfr at 0xEA CCAP0L;
sfr at 0xEB CCAP1L;
sfr at 0xEC CCAP2L;
sfr at 0xED CCAP3L;
sfr at 0xEE CCAP4L;

//Serial I/O Port SFRs
sfr at 0x98 SCON;
sfr at 0x99 SBUF;
sfr at 0xB9 SADEN;
sfr at 0xA9 SADDR;
sfr at 0x9B BDRCON;
sfr at 0x9A BRL;

//SPI Controller SFRs
sfr at 0xC3 SPCON;
sfr at 0xC4 SPSTA;
sfr at 0xC5 SPDAT;

//Keyboard Interface SFRs
sfr at 0x9C KBLS;
sfr at 0x9D KBE;
sfr at 0x9E KBF;

//EEPROM data Memory SFR
//sfr at 0x?? EECON

//SFRs The Datasheet Lost
sfr at 0x8F CKCON0;

sbit at 0xAE EC;
sbit at 0xAD ET2;
sbit at 0xAF EA;
sbit at 0xCA TR2;
sbit at 0xCF TF2;

//PORT Pins
/* P1 */
sbit at 0x90 P1_0 ;
sbit at 0x91 P1_1 ;
sbit at 0x92 P1_2 ;
sbit at 0x93 P1_3 ;
sbit at 0x94 P1_4 ;
sbit at 0x95 P1_5 ;
sbit at 0x96 P1_6 ;
sbit at 0x97 P1_7 ;


/* P2 */
sbit at 0xA0 P2_0 ;
sbit at 0xA1 P2_1 ;
sbit at 0xA2 P2_2 ;
sbit at 0xA3 P2_3 ;
sbit at 0xA4 P2_4 ;
sbit at 0xA5 P2_5 ;
sbit at 0xA6 P2_6 ;
sbit at 0xA7 P2_7 ;

/*  P3  */
sbit at 0xB0 P3_0 ;
sbit at 0xB1 P3_1 ;
sbit at 0xB2 P3_2 ;
sbit at 0xB3 P3_3 ;
sbit at 0xB4 P3_4 ;
sbit at 0xB5 P3_5 ;
sbit at 0xB6 P3_6 ;
sbit at 0xB7 P3_7 ;
